package org.dromara.knowledge.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.knowledge.domain.KnowledgeRole;
import org.dromara.knowledge.domain.bo.KnowledgeRoleBo;
import org.dromara.knowledge.domain.vo.KnowledgeRoleVo;

import java.util.Collection;
import java.util.List;

/**
 * 知识库角色Service接口
 *
 * @author pengles
 */
public interface KnowledgeRoleService extends IService<KnowledgeRole> {

    /**
     * 查询知识库角色
     */
    KnowledgeRoleVo queryById(Long id);

    /**
     * 查询知识库角色列表
     */
    TableDataInfo<KnowledgeRoleVo> queryPageList(KnowledgeRoleBo bo, PageQuery pageQuery);

    /**
     * 查询知识库角色列表
     */
    List<KnowledgeRoleVo> queryList(KnowledgeRoleBo bo);

    /**
     * 新增知识库角色
     */
    Boolean insertByBo(KnowledgeRoleBo bo);

    /**
     * 修改知识库角色
     */
    Boolean updateByBo(KnowledgeRoleBo bo);

    /**
     * 校验并批量删除知识库角色
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据角色编码查询角色信息
     */
    KnowledgeRoleVo queryByRoleCode(String roleCode);

    /**
     * 查询启用状态的角色列表
     */
    List<KnowledgeRoleVo> queryEnabledList();

}